from mini.bossmulti.Minimanager.Speaker import *

from mini.bossmulti.Minimanager import Message
from mini.bossmulti.Minimanager import Delay
from mini.bossmulti.Minimanager import Transmit
from mini.bossmulti.Minimanager import Action
from mini.bossmulti.Minimanager import MessageState

from mini.bossmulti import Borgus

from owg.util.euclidian import V2D

from mini.bossmulti.MultibossRoomSettings import Music
from audio import Audio

state = SimpleNamespace()
state.boss_music_started = False

def step():
	if (not state.boss_music_started):
		Audio.musicFrequency = 0.375

def on_intro_completed():
	mini.setConversation(
		Message(BOGUS, "Well... the bad vibes could be..."), Delay(50),
		Action(make_borgus), Delay(10),
		Message(BOGUS, "My brother..."), Transmit(60),
		Message(BORGUS, "Hey y'all"),
		Action(begin_battle),
		Delay(30),
		Action(pacifist_conversation)
	)
	
def make_borgus():
	state.borgus = Borgus(list, V2D(432, 175))
	Audio.stopMusic(5)
	world["BorgusConed"].call("begin_listening", state.borgus)

def pacifist_conversation():
	mini.setConversation(
		Message(BORGUS, "What are you two numb-skulls up too?"), Delay(80),
		Message(BORGUS, "Did you come to see the worm's?"), Delay(90),
		Message(BOGUS, "No we did not come to see the worms"), Delay(78),
		Message(BOGUS, "I wouldnt go anywhere to see some d*mn worms"), Transmit(100),
		Message(BORGUS, "Oh"), Delay(45),
		Message(BORGUS, "Well my worms alerted me of a burglar / assassin\non the loose"), Delay(110),
		Message(BORGUS, "So please be careful"), Delay(60),
		
		delay_action(240, pacifist_conversation2)
	)
	
def pacifist_conversation2():
	mini.setConversation(
		Message(DRUMMER, "(Psst... Bogey...)"), Delay(45),
		Message(BOGUS, "(Whats up?)"), Transmit(60),
		Message(DRUMMER, "(Have your forgotten the mission?)"), Delay(90),
		Message(BOGUS, "(No...)"), Transmit(60),
		Message(DRUMMER, "(Good)"),
		
		delay_action(90, pacifist_conversation3)
	)
	
def pacifist_conversation3():
	mini.setConversation(
		Message(BORGUS, "(FOOLS!!!)"), Delay(45),
		Message(BORGUS, "(Just because your texting in ()'s doesnt mean i cant read it lol!!!)"), Delay(140),
		Message(DRUMMER, "(Fuck... Guess are cover's blown)"), Delay(80),
		Message(BORGUS, "(Hahahahaha!!!! Now I know all about your scheme--)"), Delay(100),
		Message(BORGUS, "(--Your hideous Plot to collect all of my beloved iced creams)"), Delay(100),
		Message(BORGUS, "(BUT intelligent as I am, I already hid the last cream away!!!)"), Delay(100),
		Message(BORGUS, "(I hid it in the scaffolding above this platform!!!)"), Delay(100),
		Message(BORGUS, "(And prepared a mechanism that will drop the iced cream--)"), Delay(100),
		Message(BORGUS, "(--BUT only in an emergency state--)"), Delay(100),
		Message(BORGUS, "(--An emergency such as me, the towerlord, falling from this\nvery platform!!!)"), Delay(130),
		Message(BOGUS, "(Damn, your smart as sh*t Borgus!)"), Transmit(60),
		Message(BOGUS, "(You really cracked the code's this time...)"), Transmit(100),
		Message(BOGUS, "((Looks like he doesnt know the real plan, Drummy (-; ))"), Transmit(100),
		
		delay_action(240, pacifist_conversation4)
	)
	
def pacifist_conversation4():
	mini.setConversation(
		Message(BORGUS, "So?"), Delay(45),
		Message(BORGUS, "Are you just giving up?"), Delay(60),
		Message(BORGUS, "You'll never get an ice cream like this!")
	)
	
def delay_action(delay, action):
	return Action(lambda : mini.setConversation(Delay(1), Delay(delay), Action(action)))

def begin_battle():
	state.boss_music_started = True
	game.getSettings().levelActive.set(True)
	Music.BORGUS.play(3)
	
	world["Weather"].on_battle_start()
