from mini.bossmulti.Minimanager import Speaker
from mini.bossmulti.Minimanager import Message
from mini.bossmulti.Minimanager import Delay
from mini.bossmulti.Minimanager import Transmit
from mini.bossmulti.Minimanager import MessageState

from mini.bossmulti.placeable import FloorHotspot

from owg.util import Calc

state = SimpleNamespace();

state.asked_wya = False
state.accident = False
state.should_restart = False
state.worm_moved_off_switch = False

def start():
	alarm(hello).start(38)

def hello():
	adjective = Calc.choose("epic", "delightful", "classic")
	mini.message(Speaker.BOGUS, "Another " + adjective + " puzzle!")

def onKilled(worm):
	if worm.state.pos.x() > 224 and not state.should_restart:
		state.should_restart = True
		if (state.asked_wya):
			mini.setConversation(
				Message(Speaker.BOGUS, "-_-"), Delay(60),
				Message(Speaker.BOGUS, "Well, If I cannot reach\nthe Ice Cream prize..."), Delay(60),
				Message(Speaker.BOGUS, "I should probably REVIVE with [R]...")
			)
		else:
			mini.setConversation(
				Delay(120),
				Message(Speaker.BOGUS, "Hm..."), Delay(90),
				Message(Speaker.BOGUS, "I dont think i can get that\nIce Cream prize anymore..."), Delay(60),
				Message(Speaker.BOGUS, "Maybe I should REVIVE with [R]..."))

def step():
	if not state.asked_wya and mini.getHadWifi():
		state.asked_wya = True
		mini.setConversation(
			Delay(20),
			Message(Speaker.DRUMMER, "U good?"), Delay(25),
			Message(Speaker.DRUMMER, "helloooooo?"), Delay(45),
			Message(Speaker.BOGUS, "Oh sorry there was no wifi / internet."), Delay(60),
			Message(Speaker.BOGUS, "But I'm am doing fine! Donut worry !"), Transmit(30),
			Message(Speaker.DRUMMER, "Gucci :-)"))

def onFreshHurt(worm):
	if not state.asked_wya and not state.accident and worm.state.pos.x() < 576:
		state.accident = True
		mini.setConversation(
			Message(Speaker.BOGUS, "Oopsy!!"), Delay(15),
			Message(Speaker.BOGUS, "Sorrey worm... I don't want to hurt your yet."))

def onBogusHurt(bogus):
	if bogus.getX() > 730 and bogus.getY() > 220 and not state.worm_moved_off_switch:
		state.worm_moved_off_switch = True
		mini.setConversation(
			Message(Speaker.BOGUS, ":("), Delay(15),
			Message(Speaker.BOGUS, "D*mn worm!!!!"), Transmit(75),
			Message(Speaker.DRUMMER, "Um.. you still good?"), Delay(60),
			Message(Speaker.BOGUS, "I guess... :o"), Transmit(60),
			Message(Speaker.DRUMMER, "HMMMMM"))
			
def onBogusDetected(worm, fresh):
	pass