from mini.bossmulti.Minimanager import Speaker
from mini.bossmulti.Minimanager import Message
from mini.bossmulti.Minimanager import Delay
from mini.bossmulti.Minimanager import Transmit
from mini.bossmulti.Minimanager import MessageState
from mini.bossmulti.placeable import Prize
from mini.bossmulti import ConeProjectile
from owg.util.euclidian import V2F

from audio import Audio

msg = 0
cone = 0
cone_msg_phase = 0

miracles = None

def cone(alarm):
	Audio.play("miracle", None, 0.6, None, 1)
	ConeProjectile(list, None, this.state.pos.asV2F(), V2F(0,-5))
	alarm.restart(120)

def now_what():
	global cone_msg_phase
	global miracles
	miracles = Message(Speaker.DRUMMER, "Just gotta hope for a miracle, bb! ;-)")
	cone_msg_phase = cone_msg_phase + 1
	mini.setConversation(Message(Speaker.BOGUS, "Now what?"), Delay(30),
	Message(Speaker.BOGUS, "I'm stuck."), Delay(30),
	Message(Speaker.BOGUS, "There's no way across."), Transmit(30),
	miracles)
	
# (optional) called once per step
def step():
	global msg
	if (game.getCounterValue(Prize)>0 and msg < 2):
		msg = 2
		mini.setConversation(Message(Speaker.BOGUS, "Mmm, I found a tasty ice cream!"), Transmit(30),
		Message(Speaker.DRUMMER, "Bogus, you fool! Don't eat it!"), Delay(40),
		Message(Speaker.DRUMMER, "Your going to need it to max out your skill's tree's!"), Delay(75),
		Message(Speaker.BOGUS, "OK"))
	global cone_msg_phase
	if (cone_msg_phase == 2 and miracles is not None and miracles.state == MessageState.SENT):
		cone_msg_phase = 3
		alarm_restartable(cone).start(120)

def entered(area):
	global msg
	global cone_msg_phase
	if (msg==0 and area.getName() == "First"):
		msg = 1
		mini.setConversation(Message(Speaker.DRUMMER, "Hey, Bogey."), Delay(30),
		Message(Speaker.DRUMMER, "You ready to take down your nusty older bro?"), Delay(60),
		Message(Speaker.BOGUS, "Sounds good to me!"), Transmit(30),
		Message(Speaker.DRUMMER, "Good. See you soon, bb."))
	elif (cone_msg_phase == 0 and area.getName() == "NowWhat" and game.getCounterValue(Prize)>=2):
		cone_msg_phase = 1
		alarm(now_what).start(120)
	elif (cone_msg_phase == 3 and area.getName() == "WowDrummy"):
		cone_msg_phase = 4
		mini.setConversation(Message(Speaker.BOGUS, "Wow Drummy! Your so talented with cone's..."), Transmit(30),
		Message(Speaker.DRUMMER, "lol"), Delay(20),
		Message(Speaker.DRUMMER, "Thanks."), Delay(30),
		Message(Speaker.DRUMMER, "Now, go find some ice cream!"), Delay(40),
		Message(Speaker.BOGUS, "You got it!!!"))

def left(area):
	pass
		