from mini.bossmulti.Minimanager import Speaker
from mini.bossmulti.Minimanager import Message
from mini.bossmulti.Minimanager import Delay
from mini.bossmulti.Minimanager import Transmit
from mini.bossmulti.Minimanager import MessageState

from owg.util.Calc import PI

from audio import Audio

state = SimpleNamespace();
state.cone_arrangements = False
state.level_begin_started = False
state.keep_calm = False
state.got_boulder = False
state.circle = 0

mirror_rotate_interval = 30

level_begin_message = Message(Speaker.BOGUS, "sweet!")

# (optional) called when this object receives the start() event
def start():
	alarm_restartable(rotate_mirror).start(mirror_rotate_interval)

def rotate_mirror(alarm):
	Audio.play("mirror rotate", None, 0.45 if mini.cones > 0 else 0.1, None, 1 if state.circle == 3 else 0.5)
	state.circle = (state.circle + 1) % 4
	world["SpinningMirror"].angle = state.circle * PI / 2
	alarm.restart(mirror_rotate_interval)
	
def level_begin():
	game.getSettings().levelActive.set(True)

def step():
	if mini.getHadWifi() and not state.cone_arrangements:
		state.cone_arrangements = True
		mini.setConversation(Delay(10),
			Message(Speaker.DRUMMER, "O Bogey, my friend..."), Delay(45),
			Message(Speaker.DRUMMER, "I'm walking thru THAT side of town"), Delay(60),
			Message(Speaker.DRUMMER, "Theres construction's cones on the ceilings"),  Delay(80),
			Message(Speaker.BOGUS, "I see..."), Delay(30),
			Message(Speaker.BOGUS, "So what are your going to do about it?"), Transmit(70),
			Message(Speaker.DRUMMER, "Oh, thats easy!"), Delay(60),
			Message(Speaker.DRUMMER, "The trick is to simpley:\nHold [DOWN] to duck!!!"), Delay(80),
			level_begin_message)
	
	if not state.level_begin_started and level_begin_message.state == MessageState.SENT:
		state.level_begin_started = True
		alarm(level_begin).start(30)
	
	if not state.keep_calm and mini.cones > 4:
		state.keep_calm = True
		mini.setConversation(Delay(10),
			Message(Speaker.BOGUS, "I am simpley loving these cones!"), Transmit(60),
			Message(Speaker.DRUMMER, "? lol"))
	
	if not state.got_boulder and world["Rock"].isDestroyed():
		state.got_boulder = True
		mini.setConversation(Delay(5),
			Message(Speaker.BOGUS, "Yes daddy! The boulder is gone!"), Transmit(45),
			Message(Speaker.DRUMMER, "LOL your a mess"), Delay(30),
			Message(Speaker.BOGUS, "@v@"))